/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is http://developer.mozilla.org/En/Code_snippets:JS_XPCOM
 *
 * The Initial Developer of the Original Code is Mozilla Foundation.
 * Portions created by the Initial Developer are Copyright (C) 2008
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *   Alexander Sack <asac@canonical.com>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

Components.utils.import("resource://gre/modules/XPCOMUtils.jsm");
const Cc = Components.classes;
const Ci = Components.interfaces;
function AboutRightsHandler() { }

AboutRightsHandler.prototype = {
    newChannel : function(aURI) {
        var ios = Cc["@mozilla.org/network/io-service;1"].getService(Ci.nsIIOService);
        var secMan = Cc["@mozilla.org/scriptsecuritymanager;1"].
               getService(Ci.nsIScriptSecurityManager);
        var channel = ios.newChannel("chrome://browser/content/aboutRights.xhtml", null, null);
        channel.originalURI = aURI;
        var principal = secMan.getCodebasePrincipal(aURI);
        channel.owner = principal;
        return channel;
    },
    getURIFlags: function(aURI) {
        return (Ci.nsIAboutModule.ALLOW_SCRIPT |
                Ci.nsIAboutModule.URI_SAFE_FOR_UNTRUSTED_CONTENT);
    },

    classDescription: "About Rights Page",
    classID: Components.ID("a9de133c-6c09-4a6b-b376-88ad56c0a351"),
    contractID: "@mozilla.org/network/protocol/about;1?what=rights",
    QueryInterface: XPCOMUtils.generateQI([Ci.nsIAboutModule]),
}

function NSGetModule(aCompMgr, aFileSpec) {
  return XPCOMUtils.generateModule([AboutRightsHandler]);
}

